
markup.push(
{

// MARK: home window

RecordingsWindow:
{
	nsClass: "GXWindow",
	gxWindowTitle: "Recordings List",
	gxCanFullScreen: true,
	gxWindowMaxSize: "1000, 2000",
	gxWindowMinSize: "700, 510",
	gxInitialWindowSize: "790, 540",
	gxInitialWindowPosition: "0.5, 0.22",
	gxBackColor: "BackColor2",
	gxSavedWindowStateKey: "recordingsWindow",
	gxContentView: "RecordingsWindowContentView",
    gxFullSizeContentView: true,
},


// MARK: content view

RecordingsWindowContentView:
{
	nsClass: "GXDrawView",
    gxBackPainter: fillPainter("SidebarBackColor2"),
	gxWantsLayer: true,
	gxLayout:
	[
		"V:[titleBarView(26)]-8-[headings(31)]-0-[recordingsScrollView]-0-[trialBar]-0-[bottomBar(45)]-0-|",
		//"V:[titleBarView]-1-[emptyView]-1-[trialBar]",

		"H:|-0-[headings]-0-|",
		"H:|-0-[recordingsScrollView]-0-|",
		//"H:|-0-[emptyView]-0-|",
		"H:|-0-[trialBar]-0-|",
	],
	gxChildViews:
	{
		titleBarView:
		{
			"+": "TitleBarView",
            gxBackPainter:
            {
                nsClass: "GXPainter",
                gxFillColor: "SidebarBackColor2",
                gxFrameColor: "BackColor3",
                gxEdgeInsets: "-1, -1, -1, 0",
            },
			gxChildViews:
			{
				windowTitle: {
					"+": "WindowTitle",
					gxDefaultValue: "Recordings List",
				},
			},
		},
		headings: {
			"+": "RecordingsListHeadings",
		},
		emptyView: {
			nsClass: "GXDrawView",
			gxForePainter: "ImagePainter.top.foreColor3.empty-file",
			gxShowOnKey: "recordingsIsEmpty",
			axIsIgnored: false,
			axDescription: "No Recordings Yet, all recordings made by Audio Hijack will be listed here",
			gxLayerZPosition: 10,
			gxLayout: [
				"H:[superview]-(<=0)-[self(240)]&alignCenterY",
				"V:[superview]-(<=0)-[self(220)]&alignCenterX",
				"H:|-0-[label]-0-|",
				"V:[label(60)]-80-|",
			],
			gxChildViews: {
				label: labelView("<mediumWeight>No Recordings Yet</mediumWeight><size4>\n\n</size4><size12>Recordings made with Audio Hijack\nwill display here.", "foreColor3.useMarkup.wrap.centerx.size15"),
			},
		},
		recordingsScrollView: {
			nsClass: "GXScrollView",
			gxBackColor: "SidebarBackColor2",
			gxVScrollbar: "ScrollBarView",	// vertical scroller only
			gxAddViewBelow: true,
			gxDocumentView:
            {
				nsClass: "GXNewListView",
				gxModelKeyPath: "recordingsList",
				gxValueKey: "subModels",
                gxViewName: "recordingsList",
				gxItemHeight: 44,
				gxListItemView: "RecordingsListItem",
                gxLayout: "H:|-0-[self]-0-|",
                axIsIgnored: false,
				axTitle: "Recordings",
				axHelp: "List of all recordings",
                axRoleDescription: "list",
			}
		},
        trialBar: {
            "+": "TrialBarView",
            gxViewModel: { nsClass: "AH4TrialBarViewModel" },
        },
		bottomBar: {
			nsClass: "GXDrawView",
			gxBackPainter: "BottomBarBack",
			gxLayerZPosition: 10,
			gxLayout: [
				"H:|-0-[self]-0-|",
				"H:[deleteBtn(24)]-14-|&alignBaseline",
				"H:[self]-(<=0)-[deleteBtn]&alignCenterY",	// center vertically				
			],
			gxChildViews: {
				deleteBtn: {
					"+": "MinusButton",
					//gxValueKey: "deleteBtn",
					gxDisableOnNil: true,
					axDescription: "Delete selected recordings",
				},
			}
		}
	}
},


// --------------------------------------------------------
// MARK: - session list items

RecordingsListItem:
{
	nsClass: "GXListItem",
    gxViewName: "sessionItem",			
	gxSelectable: 2,
	gxIntrinsicHeight: 44,
	axRoleDescription: "Recording",
    axTitleKeyPath: "accessibilityDescription",
    axHelp: "VO press to open the session window. Interact for more controls.",
	gxBackPainter: "ListItemBack",
    gxLateLayout:
    [
		"V:[self(44)]",
		"H:|-0-[self]-0-|",

        //"H:|-0-[self]-0-|",
		"H:[_splitter1]-2-[title(250)]",
		"V:|-10-[title(23)]",
	],
	gxChildViews:
	{
		spinnerHost:
		{
			nsClass: "GXLayerHostingView",
			gxFrameRect: `$(270+8), 10, 21, 21`,
			gxShowOnKey: "isRecording",
			gxRootLayer:
			{
				nsClass: "GXCaarLayer",
				gxViewName: "spinner",
				gxAnimateOnKey: "isRecording",
				gxShowOnKey: "isRecording",
				gxAnimationDivider: 2,
				gxCaarPainter: "RecordingSpinnerPainter",
				gxTransition: {
					nsClass: "GXSpinnerTransition",
					gxDuration: 1.0,
					gxRunOn: 1.0,
				},
			}
		},
		title: {
			"+": "LabelView.top",
			//gxFrameRect: "0, 7, 270, 20",
			gxValueKey: "displayName",
			axTitle: "File Title",
			gxForePainter:
			{
				"+": "LabelFore.foreColor1.left.size13.mediumWeight",
				gxEdgeInsets: "10, 0, 10, 0",
			},
		},
		fileSize: {
			"+": "LabelView.centerx.colorThemeLive1.size12",
			gxFrameRect: `${270+152}, 12, 84, 17`,
			gxValueKey: "fileSize",
			gxAnimateOnKey: "isRecording",
			gxShowOnKey: "isRecording",
			axTitle: "File Size",
			gxFormatter: { nsClass: "PTFileSizeFormatter" }
		},
		fileTime: {
			"+": "LabelView.centerx.colorThemeLive1.size12",
			gxFrameRect: `${270+244}, 12, 50, 17`,
			gxValueKey: "fileTime",
			gxAnimateOnKey: "isRecording",
			axIsIgnored: false,
			axTitle: "File Duration",
			gxFormatter: { nsClass: "PTTrackTimeFormatter" }
		},
		recordingFormat: {
			"+": "LabelView.left.mediumWeight.colorThemeLive1.size13",
			gxFrameRect: `${270+34}, 12, 110, 17`,
			gxShowOnKey: "isRecording",
			gxToolTipKeyPath: "fullDescription"
		},
		playBtn: {
			nsClass: "GXButtonView",
			gxFrameRect: `${270+7}, 10, 17, 22`,
			gxBackPainter: "ImagePainter.foreColor1.playbtn",
			gxValueKey: "filePlayBtn",
			gxLayerZPosition: 10,
			gxButtonType: "toggle",
			axTitle: "play or pause",
			gxDisableOnKey: "isRecording",
		},
		waveForm: {
			nsClass: "GXWaveView",
			gxFrameRect: `${270+29}, 7,  215, 28`,
			gxValueKey: "playPosition",
			gxActiveWhenSelected: true,
			gxAnimateOnKey: "isPlaying",
			gxOnlyLoadWhenVisible: true,
	//            gxLayout: [
	//                "H:|-0-[fullWave]-0-|",
	//                "V:|-0-[fullWave]-0-|",
	//
	//                "H:[playhead(2)]",
	//                "V:|-0-[playhead]-0-|",
	//            ],
			gxRootLayer:
			{
				nsClass: "GXDrawLayer",
				gxLayerZPosition: 2,
				gxSublayers:
				{
					fullWave: {
						nsClass: "GXWaveLayer",
						gxLayerZPosition: 4,
						gxValueKey: "waveData",
						gxFrameRect: "0, 0, 215, 28",
						gxNeedsDisplayOnResize: true,
						gxPainter: {    // only provides colors
							nsClass: "GXPainter",
							gxFillColor: "ForeColor1",
						},
					},
					playhead: {
						// playhead is a puppet created for GXWaveView to use
						nsClass: "GXDrawLayer",
						gxFrameRect: "0, 0, 2, 28",
						gxLayerZPosition: 10,
						gxBackPainter: {    // only used for colors
							nsClass: "GXPainter",
							gxCornerRadius: 1,
							gxBackColor: "ColorThemeLive1",
							//selected: { gxBackColor: "ForeColor2", }
						},
					},
				}
			}
		},
	}
},

// --------------------------------------------------------
// MARK: session list headings

RecordingsListHeadings:
{
	nsClass: "GXDrawView",
	gxBackPainter: fillPainter("SidebarBackColor2"),
    axIsIgnored: true,
    axDescription: "Session list column headings",
	gxLayout: [
		"V:|-0-[name]",
		"H:|-12-[name(>=50)]-2-[splitter1(4)]-2-[sources(90)]-8-[autoRun(78)]-4-[status(100)]&alignBaseline",
		
	],
	gxChildViews:
	{
        name: {
            "+": "LabelView.left.thinWeight",
            //gxIntrinsicWidth: -1,
            gxDefaultValue: "Name",
        },
		splitter1: {
			nsClass: "GXSplitterView",
			gxBackPainter: fillPainter("BlackColor"),
			gxIntrinsicHeight: 20,
		},
		sources: labelView("Sources", "left.thinWeight"),
		autoRun: labelView("Auto Run", "left.thinWeight"),
		status: labelView("Status", "right.thinWeight"),
	}
},



	
})
